// DISPLAY.C  -  SCREEN DISPLAY SOFTWARE FOR IONOGRAM COLLECTION.
// CLEANIT (copied from  CLEAN),  and functions:
void display(struct iodes *iodesp);  //display full ionogram as collected.
void grafmode(void);                 //initialise graphics
#include "type.h"
#include "file.h"
#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

void cleanit (struct iodes *iodesp)				//delete unwanted areas & dots.
{	int nc, ht, nh;                                       //ht: 1 Byte= 12.5km
	int minht= 7, timht= 56, timcol= 256;             //datime= 256col *8bytes
	int minfreq= 48, maxfreq= 512;                            //=1.3 to 16 MHz
	long off, length;
	buf *bp, *bpa;  byte b;
///		 minfreq= 1;  maxfreq= 577;
	ht = iodesp->height; 									  // bytes per col
	minfreq= max( minfreq, iodesp->lcol );
	iodesp->lcol = minfreq;						  //save only minfreq->maxfreq
	iodesp->rcol = maxfreq;
	bpa = iodesp->bufp;     								  //orig buf start
	bp  = bpa + (minfreq-1)*ht;			 					  //new buff start
	iodesp->bufp = bp;
	memset(bpa, 0, bp - bpa);			   				  	//zero start freqs
	for (nc= minfreq; nc<=maxfreq; nc++)	//-------------zero bot, top areas
	  {	memset(bp, 0, minht-1);					 			  //zero bot 75km
///		if (nc<100)  memset(bp+mxht, 0, ht-mxht);  else.. //zero >400km
		if (nc<timcol)  memset(bp+timht, 0, ht-timht);		  //zero date-time
		bp += ht;  }                      	//---end zero areas
	memset(bp, 0, (577-maxfreq)*ht);					  	  //zero end freqs

	for (nc= minfreq; nc<=maxfreq; nc++)	//---clean isolated dots
	 {	bp = bpa + (nc-1)*ht + minht - 1;
		for (nh=minht; nh<=ht; nh++)
		 {	b = *(++bp);
			if (b>0 && (b==1||b==2||b==4||b==8||b==16||b==32||b==64||b==128) )
			  {	if (*(bp+64) !=0 || *(bp+128) !=0) continue;	//2 next f >0
				if (*(bp-64) !=0 || *(bp-128) !=0) continue;	//2 prev f >0
				if (*(bp+ 1) !=0 || *(bp+ 65) !=0) continue;    //Top, TopRight
				if (*(bp- 1) !=0 || *(bp- 65) !=0) continue;    //Bot, BotLeft
				if (*(bp-129)!=0 || *(bp-193) !=0) continue;	//2 prev below
				*bp = 0;  }//end if								//zero bit
		;}//end this col
	;}//end all cols
}//end cleanit


void display(iodesp)		//called from control
struct iodes *iodesp;
{   buf *bp, mask=0x80, bite;
	int nc, nb, k, ht, maxy, ymax, ymin;
	int xs, xm, xp, yp, yht, ns, nskip;
	if ((k=iodesp->rcol)<99) {printf("\n Omit plot, only %d freqs.",k); return;}
	grafmode();
	bp = iodesp->bufp - 1;
	xs = 40;   xm = xs + 576;  									//x= 40 to 616
	xp = xs + iodesp->lcol - 2;                                 //1st xp+1= 40
	ymax= getmaxy();										//herc=347,VGA=479
	ht = iodesp->height;
	yht= ht * 8;												//bits= pixels
	nskip= yht / (yht - 0.986*ymax);		     //skip# to fit(Herc=3,VGA=12)
	for (nc= iodesp->lcol; nc<= iodesp->rcol; ++nc)			//step freq cols.
	{ 	ns = nskip;
		++xp;  maxy = ymax;        						//new freq, at next xp
		for (nb = 1; nb <= ht; ++nb)           				// do all bytes
		{	++bp; bite= *bp;                				// get next byte
			for (k = 1; k <= 8; ++k)		   				// test bits 1 - 8
			  {	if (--ns ==0) {ns= nskip; bite<<=1; continue;}  //omit point
				if (bite & mask) putpixel( xp, maxy, 9 );  		//14Y,9LB,
				bite <<= 1;  --maxy;  }    			  			// for next ht
		}//end bytes at this freq
	}//end this freq
	setlinestyle(DOTTED_LINE, 1, 1);		//-----add dotted frame
	ymin = ymax - (long)(512*(nskip-1)) /nskip;
	rectangle(xs, ymin, xs+576, ymax);
	for (k= 64; k < 550; k+=64)  {
		xp = xs + k;  yp = ymax - k*(nskip-1)/nskip;
		line(xp,ymax, xp,ymax-6);  line(xp,ymin, xp,ymin+6);	//tick bot,top
		line(xs,yp, xs+6,yp);  line(xm,yp, xm-6,yp); }		 //tick left,right
	setlinestyle(SOLID_LINE, 1, 1);
}//end display.  ret to control

void grafmode(void)
{	int graphdriver = DETECT, graphmode, errorcode;
	errorcode = registerbgidriver(EGAVGA_driver);
	errorcode = registerbgidriver(Herc_driver);
	if (errorcode < 0)  {
		printf("Graph_driver error: %s\n", grapherrormsg(errorcode));
		exit(1); }
	initgraph(&graphdriver, &graphmode, "");
	errorcode = graphresult();
	if (errorcode != grOk)  {
		printf("Init_Graph error: %s\n", grapherrormsg(errorcode));
		exit(1);  }
	setactivepage(0);  setvisualpage(0);
}//end grafmode
