// FILE.H.   As used by  DIGION,  VARION  and  RELION.

// Header written at the beginning of each file, on disk
struct  fhead    {
    int    fnum;       // Total Number of ionograms in file.
    long   fsize;      // Total file size in bytes.
    byte   fsite;      // Station: 0,1=Ackld, 2=Chch,
    byte   fofset;     // Pixel offset to use for this data file.
    int    fyear;      // Year of file - year not recorded with
    byte   fmonth;     //                individual ionograms.
    byte   fday;
    byte   fhour;      // Date is last file modification date.
    byte   fminute;
    byte   fsecond;
    byte   fflags;     // Various flags - see below.
    };

//  Header written before every compacted ionogram in a file.
struct    ihead  {
    int   inum;       // Unique no. of ionogram.  In sequence.
    int   ilcol;      // Left-hand column of ionogram.
    int   ircol;      // Right-hand column of ionogram.
    int   iheight;    // Height in bytes of ionogram.
    int   isize;      // Size in 16-byte blks of compacted 'gram.
    byte  imonth;     // Date that ionogram was recorded.
    byte  iday;
    byte  ihour;
    byte  iminute;
    byte  isecond;    // Relates to start of ionogram.
    byte  iflags;     // Various flags - see iono.h & comment directly below.
    };
// Only some flag bits defined in iono.h are stored on disk.
// Use DISKFLAGS as a mask to remove the others.
#define DISKFLAGS   0x3F

// Miscellaneous
#define BLKSIZE     16  /* Size of block units in ionogram file. */
#define BLKSHFT		4	/* bytecount = blockcount << BLKSHFT. */
#define HSIZE		16	/* Size of header structs above. */
#define LHSIZE		16L	/* Ditto in double precision. */

/// gramflag values to load next ionogram.  >=0 is ionog#.
#define FRST        -90
#define LAST        -99
#define PREV        -98
#define NEXT        -97
#define SAME        -96
#define PGON        -95
#define PGBK        -94
#define LGON        -93
#define LGBK        -92
#define NEWFIL     -100
#define FILON      -101
#define FILBK      -102
#define DAYON      -103
#define DAYBK      -104

