//SCAN.C  MACROSCOPIC CONTROL OF IONOGRAM SCANS.
//           getscan calls  vidscan;  which calls  waitsound, &  sounds(*577).
#include	"type.h"
errnum getscan ( struct iodes *iodesp);  //set memory, pointers; call vidscan.
errnum vidscan ( struct iodes *iodesp);	 //takes iodesp & returns full ionog.
errnum waitsound(void);  				 //wait to t-2sec, & issue MONREQ.
#include	"globals.h"
#include	"file.h"
#include	"errors.h"
#include	"signals.h"
#include    <alloc.h>
#include	<stdio.h>
#include 	<dos.h>
#include 	<mem.h>

// getscan(iodesp)  Takes an iodescriptor, returns unprocessed ionog in bufp.
// Sets lcol=1, rcol=577, ht=64 in vidscan(),  which calls sounds()*577.
errnum getscan( iodesp )
struct iodes *iodesp;
{	extern errnum sync(void);
	extern void panic(char *s, int status);
	static byte synchr;
    int err, i, l, r, h;
	unsigned int memspace;
	buf *bp;
	if(debug) printf("\nIn GETSCAN(); -> VIDSCAN.");
	if ( (l= iodesp->lcol) <= 0 )  l = iodesp->lcol = 1;
	if ( (r= iodesp->rcol) < l || r>577)  r = iodesp->rcol = 577;
	  if ( (h= iodesp->height)== -1 )  return( ESRATE );
	memspace = (r-l+2)*h + MMARGIN;
	  if ( ( bp=(buf *)malloc(memspace) ) == NULL )
		  {	printf("\nl=%d, r=%d, h=%d, -> memspace %d", memspace);
			panic ("No memory to store ionogram.",  ABORT); }
	iodesp->bufp = bp;
	iodesp->flags = MONSCAN;
//----------------------------------- GET THE IONOGRAM
    err = vidscan( iodesp );                         //-> waitsound; sounds*577
      if (err != OK) { printf("  error= %d", err);  return(err); }      //->reset
	gettimes((byte *)&iodesp->year );               //set date,time in iodesp-
	iodesp->second -= 7;                            //-correct secs to centre
	if (iodesp->hour != synchr)  {	                   	  		 //every hour-
		printf( "\nRe-synchronise Clocks in Getscan: ");	     //-sync clock
        err = sync();  synchr= iodesp->hour;  }
///	else delay(3000u);									//to read sweep result
    return( err );                                                  //err->reset
}//end getscan.  ret to control (-> save,show ionog & repeat).

// vidscan() takes an ionogram descriptor iodes, and sets lcol,rcol,ht.
// Then: waitscan() starts IPS-42: sounds()*577 gets data into iodes->bufp.
errnum vidscan( iodesp )		//calls waitsound, & then sounds(*577).
struct iodes *iodesp;
{	extern errnum sounds();
	extern void beep(void);
	extern errnum waitlo(unsigned int port, byte mask, unsigned long howlong);
	buf *bp;  int *dp;										//bufs 1, 2-byte
	unsigned int m;
    int lc, rc, ht, i, b, xflag, decho, dskip= 0;
    int err, errcnt= 0, yhier= 0, rdyerrs= 0, firsterr= 0, lasterr= 0;
    byte c, echo1[600];
	int D98 = 0x0FF0;    				//test 2-byte echo. stored Lo,Hi->F00F
	int D99 = 0x2CE3;    				//Lo,Hi -> E3 2C = 1110.0011 0010.1100
	lc = iodesp->lcol = 1;   								//left freq  ( 1 )
	rc = iodesp->rcol = 577; 	                    		//right freq (577)
	ht = iodesp->height= 64;                  				// # bytes (64)
	if(debug)printf("\n  VIDSCAN() freqs %d to %d, height= %d bytes.",lc,rc,ht);
//-----------------------------	ACTIVATE IONOSONDE
	bp = iodesp->bufp;
	memset(bp, 0, (rc-lc+1)*ht);     			//zero bufr (for missed freqs)
	dskip = 0;  if (debug>90) dskip = debug - 90;		//!= 0 for dummy data
			  if (debug<-90) dskip = -debug - 90;		//read-data 1:dskip
	decho = D99;  if (dskip%2==0) decho = D98;		//test echos, stored Lo,Hi
    if ( (err= waitsound()) != 0 )           //send MONREQ, wait Ylo, +1.9 sec
                return( err );               // EISLOW or EDEAD; leave vidscan
		if (dskip) printf(" MODEL DATA at F=");
//-----------------------------	COLLECT IONOGRAM
//init    errcnt= rdyerrs= firsterr= lasterr= 0;
	iodesp->flags |= 1;                //bit 1 increases initial wait for Yhi.
	for ( i = lc; i <= rc; i++ )	   //Loop for each freq. Starts at Y->high
    {   err= OK;  rdynum= 0;           // rdynum counts # data_ready in sounds
		if ( debug > 90 )                                ////////no ionosonde-
		  { if ((i-lc)%dskip == 0 )
			  { dp = (int *)bp;	    	                      /////store data-
				for (b=0; b<ht; b +=2)  *dp++ = decho;	    	    ///-store
				printf(" %d",i); } 									///-show
			rdynum = ht;  }								 /////////////check OK
        else if ( (err= sounds(bp,ht,iodesp->flags)) != 0)   //----SOUNDING----
          { if (errcnt==0) firsterr= err;
            ++errcnt;  lasterr= err;
            if (err==ESTARTED)                          // Y starts high-
              { yhier++;  *(bp + ht - 2) = 0xFF;            //- flag one byte
				waitlo( PORTB, YBIT, WLONG ); }  			//-wait till Y low
		  }	//------------------ END SCAN this freq (& errchk).  Step counters
         if (err!=ESTARTED) rdyerrs+=(rdynum-ht);   //-ve if data-ready absent
         if (errcnt >99)  break;                    //#errors: allow up to 99
		iodesp->flags &= 0xFE;						//bit 1-> 0 after 1st freq
		echo1[i]= *bp;								//save 1st byte for errchk
		if (dskip==0)  bp += ht;					//step to store next freq
		  else if ( (i-lc)%dskip ==0 )  bp += (dskip*ht);	 //lab leave zeros
        delay (12U);         //wait 12ms till Tx done; then loop freq(was 13U)
	}//end for: freq loop
//-----------------------------	IONOGRAM ALL DONE
	rc = iodesp->rcol = i - 1;					// store true # recorded freqs
			   printf(" : Freqs %d to %d recorded.", lc, rc);
    if (errcnt || ernum || rdyerrs)
        printf("\n##ERRORS in SOUND(): %d - %d ", firsterr, lasterr);
    if ( err )  printf( "\n EISDEAD(%d), ",  err);
    if (errcnt) printf( "\n ErrorCount= %d, ",  errcnt);
	if (ernum)  printf( " ErrorNum %d.",  ernum);
    if (yhier)  printf("\nY Already-high Errors= %d",  yhier);
	if (rdyerrs)printf("\n  Data-Ready  Errors = %d", rdyerrs);
		for ( i= 2, c= echo1[1];  i< rc;  ++i )			//check for bad data
			{ if ( (echo1[i]) != c)  break; }
		if (i==iodesp->rcol) printf("\n 1st DATA BYTES ALL= %x hex.\n", c);
    if (err||ernum||errcnt||rdyerrs)  { beep();  delay(4000u); }
	if (debug)  printf("\nLeaving VIDSCAN().");
	return( abs(rdyerrs) >3000 || errcnt >50 );			//any true-> e=1,reset
}//end vidscan.  return to getscan.

errnum waitsound(void)  	//Send MONREQ to initiate Sweep, Wait (20sec) for
{   extern int gettimes(byte *time);        // Y->Low; wait 1.95 sec; Return.
	extern errnum waitlo(unsigned int port, byte mask, unsigned long howlong);
	int er;
	printf("\n   ->WAITSOUND():Trigger Sweep.");
	outportb( CTRLPORT, SCANONBYTE ); delay(50U);		//50 ms MonReq pulse.
	outportb( CTRLPORT, SCANOFBYTE );
	if (debug) printf("  WAIT for Y ->Low (at 0,20,40s)...");
	if ( (er= waitlo(PORTC,YBIT,FOREVER)) != 0 )		//Wait for Y -> Low;
			return(er); 								//er= EISLOW or EDEAD
	if (debug) printf("\n   ->SOUND in 2 secs...");
    delay(1900U);          //Delay 1.90sec, then-> sounds() (waits for Y-> hi)
    return( OK );          ///(was 1.98sec; missed 1st freq)
}//end waitsound.  return to vidscan.
