//SIGNAL.C = waithi, waitlo,  linehi, linelo  to examine hardware inputs.
#include	"type.h"
#include	"file.h"
#include	"globals.h"
#include	"errors.h"
#include	"signals.h"
#include	<stdio.h>
#include    <dos.h>
#include	<conio.h>
#include	<graphics.h>

// waithi(port,mask,howlong) waits howlong for (any one of) the signal(s) on
// port, defined by mask, to come high.  Returns EISHIGH if sigs already high.
// Returns EDEAD if sigs don't come high before howlong times round loop.
// Returns only on keyhit if howlong= "FOREVER", and sigs stay low.
errnum waithi( port, mask, howlong )
unsigned int port;  byte mask;  unsigned long howlong;
{	extern void clrkbd(void);
	unsigned long i;  int c;  c = 0;
	if ( inportb(port)&mask )  return( EISHIGH );
	if ( howlong == FOREVER )
	  {	clrkbd();   if(debug) printf("[kbd->cont]");
		while ((inportb(port)&mask)== 0)
			if (kbhit()) {c= getch(); break;}   }
	else { i = howlong;
		while ((inportb(port)&mask)== 0)
			if (i--==0) return(EDEAD); 	}
	if (c==27) { closegraph(); exit(0); }						   //esc->exit
	return( OK );
}//end waithi.  ret--

// waitlo(port, mask, howlong) returns OK when masked sigs go low (see waithi).
errnum waitlo( port, mask, howlong )     //called scan.117, time.38
unsigned int port;	byte mask;  unsigned long howlong;
{	extern void clrkbd(void);
	unsigned long int i;  int c;
	if ( (inportb(port)&mask) != mask )
	  {	if(debug) printf("\nReturning from waitlo with EISLOW");
		return( EISLOW ); }
	if (howlong==FOREVER)
	  {	clrkbd();   if(debug) printf("[kbd->cont]");
		while ((inportb(port)&mask)==mask)
			if (kbhit()) {c=getch(); break;}  }
	else  {	i= howlong;
		while ((inportb(port)&mask) == mask)
			if (i--==0) return(EDEAD);  }
	if (c==27) { closegraph(); exit(0); }						   //esc->exit
	return( OK );
}//end waitlo.  ret to waitsound, or sync.

// linehi/lo (port, mask) return TRUE if ALL signals defined by
// mask in port are high/low at the moment of test.
yesno linehi( port, mask )
unsigned int port;  byte mask;
{ 	if ( (inportb( port )&mask )==mask )  return( TRUE );
	return( FALSE );  }

yesno linelo( port, mask )
unsigned int port;  byte mask;
{	if ( ( inportb( port )&mask ) == 0 )  return( TRUE );
	return( FALSE );  }
