// TIME.C = original  time1 & time2.   Contains functions:
#include	"type.h"
errnum sync(void);		 		// Synchronise computer time with ionosonde.
yesno  wait(int secdelay);      // Wait secdelay(or Kbd); returns TRUE(FALSE).
errnum settimes(byte time[7]);  // Set date, time from time[] into computer.
int    gettimes(byte time[7]);  // yr,mon,day, hr,min,sec->time[]; returns yr.
#include	"errors.h"
#include	"signals.h"
#include	<stdio.h>
#include	<conio.h>
#include	<dos.h>
// Int 21H  funcn #s, (go in register AH)  for  sysint21(regs, regs) call.
#define GETDATE     0x2A    // Returns date in  CX,DH,DL    ( yr,mo,dy ).
#define SETDATE     0x2B    // Sets date  from  CX,DH,DL
#define GETTIME     0x2C    // Returns time in  CH,CL,DH,DL ( hr,mn,sec,csec ).
#define SETTIME     0x2D    // Sets time  from  CH,CL,DH,DL
extern int debug, monthlen[];
int   monthlen[12] = {31,28,31, 30,31,30, 31,31,30, 31,30,31};

errnum sync(void)		//	Synchronise computer time with ionosonde time.
{	extern void clrkbd(void);
	extern int 	  gettimes(byte time[]);
	extern errnum settimes(byte time[]);
	extern errnum waithi(unsigned int port, byte mask, unsigned long howlong);
	extern errnum waitlo(unsigned int port, byte mask, unsigned long howlong);
	extern yesno  linehi(unsigned int port, byte mask);
	extern yesno  linelo(unsigned int port, byte mask);
	int e, errcount,sse;
	byte sec, time[7];
lup:	errcount = 0;  ///waithi,lo(signals) prev 'exit' on kbd; change to 'break'
	if ( linelo( PORTC, MINBIT ) )
	  {	if(debug) printf(" MIN low; WAITing to go high....");
		while ( (e=waithi(PORTC,MINBIT,FOREVER)) != OK )
				if (++errcount > MAXERRORS)  return( e );
		sec = 0;  }
	else
	  {	if(debug) printf(" MIN high; WAITing to go low....");
		while ( (e=waitlo(PORTC,MINBIT,FOREVER)) != OK )
				if (++errcount > MAXERRORS)  return( e );
		sec = 20; }
	clrkbd(); 	///
	gettimes(time);
//printf("\nRead %02d:%02d", time[5],time[6]);
	if (time[6] - sec > 30)									/// > 30s fast;
	  {	time[5] += 1; 										///   min+1 ?
		if (time[5]==60) {time[4] +=1; time[5]= 0;} }		///or min=0, hr+1?
	time[6] = sec;			 								/// secs= 0 or 20.
//settimes(time); printf("  Set %02d:%02d",time[5],time[6]); goto lup;
	return( settimes(time) );
}//end sync;  ret getion, scan.

int gettimes( time ) //-> yr,mon,day, hr,min,sec in time[]. Returns int year.
byte time[7];
{	union REGS rp;
	int yr;
	rp.h.ah = GETDATE;
	intdos( &rp, &rp );
	yr = ( rp.h.ch << 8 ) + rp.h.cl;
	time[0] = rp.h.cl;
	time[1] = rp.h.ch;
	time[2] = rp.h.dh;
	time[3] = rp.h.dl;
	rp.h.ah = GETTIME;
	intdos( &rp, &rp );
	time[4] = rp.h.ch;
	time[5] = rp.h.cl;
	time[6] = rp.h.dh;
	return( yr );
}//end gettimes

// Takes pointer to date and time info, e.g. &iogram[ x ].year, fills in
// date and time from that info, and returns any error in date/time setting.
errnum settimes( byte time[7] )
{	union REGS rp;
	rp.h.ah = SETDATE;
	rp.h.cl = time[0];
	rp.h.ch = time[1];
	rp.h.dh = time[2];
	rp.h.dl = time[3];
	intdos(&rp, &rp );
	if (rp.h.al)  return( EDATE );
	rp.h.ah = SETTIME;
	rp.h.ch = time[4];
	rp.h.cl = time[5];
	rp.h.dh = time[6];
	rp.h.dl = 0;
	intdos(&rp, &rp );
	if (rp.h.al)  return( ETIME );
	return( OK );
}//end settimes

yesno wait(int secdelay ) //wait for given #secs, or key press. used in disk1
{	extern void clrkbd(void);  			//normal return TRUE;  kbd -> FALSE.
	int i;
	clrkbd();
	for (i=0; i<secdelay*4; i++)			//wait; check kbd every 1/4 sec.
		{ delay(250U);  if (kbhit()) return(FALSE); }
	return( TRUE );
}//end wait
